:
########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../bin/validate.sh  1.5  Delta: 5/18/90
########################################################################
# 
# validate.sh
# author: loren west
# 
# This program validates the existence of the database selected
# from the company form.
# It will create a new database at the users request.
# It communicates to the FourGen:Menus script by exiting with
# a 0 if the database is found, or a 1 if the database isn't found.
#

: ${company:=standard}

dirs=`echo $DBPATH | sed "s/:/ /g"`

# the following is for "no newline" processing for the echo command
a=`echo -n`
if test "$a" = "-n"
then
    # echo doesn't know about the -n...
    nl1=""; nl2="\c"
else
    # echo knows about the -n...
    nl1="-n "; nl2=""
fi

dbdir=${company}.dbs

for datadir in $dirs
do
    cd $datadir
    if test -d $dbdir
    then
        # Database found
        exit 0
    fi
done

# database was not found in $DBPATH

echo ${nl1}"
Cannot find the company.

Do you wish to create a NEW company: '$company'? (Y/N): "${nl2}
read answer

case "$answer" in
  Y|y|Yes|YES|yes)
    echo ${nl1}"
Do you wish to load it with SAMPLE data? (Y-sample/N-standard): "${nl2}
    read answer
    case "$answer" in
      Y|y|Yes|YES|yes)
        data=sample;;
      N|n|No|NO|no)
        data=standard;;
      *)
        exit 1;;
    esac
    $fg/accounting/bin/reload.dat -d $company $data
    exit_status=$?
    echo "Press [Enter] to continue ... \c"
    read junk
    exit $exit_status;;    # exit with the exit status of reload.dat
  *)
    exit 1;;
esac
exit 0
