#####################################################################
# Copyright (C) 1988,1989
# Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/all/schema.4gl  1.8  Delta: 6/1/90
#####################################################################

# This file represents the internal definition of
# the tables, columns, indexes, and views.
# It has been automatically generated using FourGen CASE tools.

globals "globals.4gl"

#####################################################################
function define_data()
#####################################################################
#
    define
        a char(18),   # holding bin for the column name
        b smallint,   # holding bin for the column type
        c smallint,   # holding bin for the column length
        d char(1),    # (Y/N) unique index?
        e char(1),    # (Y/N) clustered index?
        f smallint,   # part 1 of index
        g smallint,   # part 2 of index
        h smallint,   # part 3 of index
        i smallint,   # part 4 of index
        j smallint,   # part 5 of index
        k smallint,   # part 6 of index
        l smallint,   # part 7 of index
        m smallint,   # part 8 of index
        n smallint,   # generic counter
        t char(45)    # text portion of the view

    # Set the array boundaries
    let gn_tab = 25    # number of active elements in the tab[] array
    let gx_tab = 25    # maximum number of elements in the tab[] array
    let gn_col = 115   # number of active elements in the col[] array
    let gx_col = 115   # maximum number of elements in the col[] array
    let gn_idx = 19    # number of active elements in the idx[] array
    let gx_idx = 19    # maximum number of elements in the idx[] array
    let gn_viw = 20    # number of active elements in the viw[] array
    let gx_viw = 20    # maximum number of elements in the viw[] array

    # Set some default table elements
    for n = 1 to gn_tab
        let tab[n].col_start = 0
        let tab[n].col_end = 0
        let tab[n].idx_start = 0
        let tab[n].idx_end = 0
        let tab[n].viw_start = 0
        let tab[n].viw_end = 0
    end for

    # Table: pcdtablr
    let tab[1].tabname = "pcdtablr"
    let tab[1].col_start = 1
    let tab[1].col_end = 3
    let tab[1].idx_start = 1
    let tab[1].idx_end = 1
    let tab[1].serial_start = 1000
    for n = 1 to 3
        case n
          when 1  let a="prodid"  let b=256  let c=8
          when 2  let a="line_no"  let b=1  let c=2
          when 3  let a="tabname"  let b=256  let c=18
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxprogr
    let tab[2].tabname = "stxprogr"
    let tab[2].col_start = 4
    let tab[2].col_end = 7
    let tab[2].idx_start = 2
    let tab[2].idx_end = 2
    let tab[2].serial_start = 1000
    for n = 4 to 7
        case n
          when 4  let a="module"  let b=0  let c=8
          when 5  let a="progname"  let b=0  let c=8
          when 6  let a="description"  let b=0  let c=30
          when 7  let a="use_trx"  let b=1  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxcompr
    let tab[3].tabname = "stxcompr"
    let tab[3].col_start = 8
    let tab[3].col_end = 10
    let tab[3].serial_start = 1000
    for n = 8 to 10
        case n
          when 8  let a="comp_id"  let b=0  let c=8
          when 9  let a="db_name"  let b=0  let c=14
          when 10  let a="logfile"  let b=0  let c=150
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxcntrc
    let tab[4].tabname = "stxcntrc"
    let tab[4].col_start = 11
    let tab[4].col_end = 26
    let tab[4].serial_start = 1000
    for n = 11 to 26
        case n
          when 11  let a="co_name"  let b=0  let c=30
          when 12  let a="addr1"  let b=0  let c=30
          when 13  let a="addr2"  let b=0  let c=30
          when 14  let a="city"  let b=0  let c=20
          when 15  let a="state"  let b=0  let c=2
          when 16  let a="zip"  let b=0  let c=10
          when 17  let a="county"  let b=0  let c=30
          when 18  let a="country"  let b=0  let c=30
          when 19  let a="curr_asset"  let b=2  let c=4
          when 20  let a="fixed_asset"  let b=2  let c=4
          when 21  let a="curr_liab"  let b=2  let c=4
          when 22  let a="long_term_liab"  let b=2  let c=4
          when 23  let a="capital"  let b=2  let c=4
          when 24  let a="income"  let b=2  let c=4
          when 25  let a="cost_goods"  let b=2  let c=4
          when 26  let a="expense"  let b=2  let c=4
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxperdr
    let tab[5].tabname = "stxperdr"
    let tab[5].col_start = 27
    let tab[5].col_end = 31
    let tab[5].serial_start = 1000
    for n = 27 to 31
        case n
          when 27  let a="period"  let b=0  let c=2
          when 28  let a="period_year"  let b=0  let c=4
          when 29  let a="start_date"  let b=7  let c=4
          when 30  let a="end_date"  let b=7  let c=4
          when 31  let a="balanced"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxchrtr
    let tab[6].tabname = "stxchrtr"
    let tab[6].col_start = 32
    let tab[6].col_end = 38
    let tab[6].idx_start = 3
    let tab[6].idx_end = 3
    let tab[6].serial_start = 1000
    for n = 32 to 38
        case n
          when 32  let a="acct_no"  let b=258  let c=4
          when 33  let a="acct_type"  let b=0  let c=15
          when 34  let a="acct_desc"  let b=0  let c=30
          when 35  let a="acct_cat"  let b=0  let c=1
          when 36  let a="processing_seq"  let b=0  let c=1
          when 37  let a="incr_with_crdt"  let b=0  let c=1
          when 38  let a="subtotal_group"  let b=0  let c=30
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxchrtd
    let tab[7].tabname = "stxchrtd"
    let tab[7].col_start = 39
    let tab[7].col_end = 46
    let tab[7].idx_start = 4
    let tab[7].idx_end = 4
    let tab[7].serial_start = 1000
    for n = 39 to 46
        case n
          when 39  let a="acct_no"  let b=258  let c=4
          when 40  let a="department"  let b=256  let c=3
          when 41  let a="period_month"  let b=256  let c=2
          when 42  let a="period_year"  let b=256  let c=4
          when 43  let a="activity"  let b=5  let c=3327
          when 44  let a="balance"  let b=5  let c=3327
          when 45  let a="this_month"  let b=5  let c=3327
          when 46  let a="budget"  let b=5  let c=3327
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxtranr
    let tab[8].tabname = "stxtranr"
    let tab[8].col_start = 47
    let tab[8].col_end = 53
    let tab[8].idx_start = 5
    let tab[8].idx_end = 6
    let tab[8].serial_start = 1000
    for n = 47 to 53
        case n
          when 47  let a="orig_journal"  let b=256  let c=2
          when 48  let a="doc_no"  let b=258  let c=4
          when 49  let a="post_no"  let b=2  let c=4
          when 50  let a="post_date"  let b=7  let c=4
          when 51  let a="doc_date"  let b=263  let c=4
          when 52  let a="ref_code"  let b=0  let c=6
          when 53  let a="doc_desc"  let b=0  let c=30
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxinfor
    let tab[9].tabname = "stxinfor"
    let tab[9].col_start = 54
    let tab[9].col_end = 59
    let tab[9].idx_start = 7
    let tab[9].idx_end = 7
    let tab[9].serial_start = 1000
    for n = 54 to 59
        case n
          when 54  let a="src_type"  let b=0  let c=1
          when 55  let a="src_key"  let b=0  let c=6
          when 56  let a="src_desc"  let b=0  let c=30
          when 57  let a="src_num_desc"  let b=5  let c=3327
          when 58  let a="src_char_desc"  let b=0  let c=6
          when 59  let a="src_acct_no"  let b=2  let c=4
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxactgr
    let tab[10].tabname = "stxactgr"
    let tab[10].col_start = 60
    let tab[10].col_end = 61
    let tab[10].serial_start = 1000
    for n = 60 to 61
        case n
          when 60  let a="grp_key"  let b=0  let c=6
          when 61  let a="grp_desc"  let b=0  let c=30
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxactgd
    let tab[11].tabname = "stxactgd"
    let tab[11].col_start = 62
    let tab[11].col_end = 65
    let tab[11].idx_start = 8
    let tab[11].idx_end = 8
    let tab[11].serial_start = 1000
    for n = 62 to 65
        case n
          when 62  let a="grp_key"  let b=0  let c=6
          when 63  let a="line_no"  let b=1  let c=2
          when 64  let a="acct_no"  let b=2  let c=4
          when 65  let a="department"  let b=0  let c=3
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxerorh
    let tab[12].tabname = "stxerorh"
    let tab[12].col_start = 66
    let tab[12].col_end = 69
    let tab[12].idx_start = 9
    let tab[12].idx_end = 9
    let tab[12].serial_start = 1000
    for n = 66 to 69
        case n
          when 66  let a="err_module"  let b=0  let c=8
          when 67  let a="err_program"  let b=0  let c=8
          when 68  let a="err_number"  let b=1  let c=2
          when 69  let a="err_line"  let b=0  let c=40
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxerord
    let tab[13].tabname = "stxerord"
    let tab[13].col_start = 70
    let tab[13].col_end = 75
    let tab[13].idx_start = 10
    let tab[13].idx_end = 10
    let tab[13].serial_start = 1000
    for n = 70 to 75
        case n
          when 70  let a="err_module"  let b=0  let c=8
          when 71  let a="err_program"  let b=0  let c=8
          when 72  let a="err_number"  let b=1  let c=2
          when 73  let a="a_b"  let b=0  let c=1
          when 74  let a="line_no"  let b=1  let c=2
          when 75  let a="err_text"  let b=0  let c=60
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxhelph
    let tab[14].tabname = "stxhelph"
    let tab[14].col_start = 76
    let tab[14].col_end = 78
    let tab[14].idx_start = 11
    let tab[14].idx_end = 11
    let tab[14].serial_start = 1000
    for n = 76 to 78
        case n
          when 76  let a="hlp_module"  let b=0  let c=8
          when 77  let a="hlp_program"  let b=0  let c=8
          when 78  let a="hlp_number"  let b=1  let c=2
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxhelpd
    let tab[15].tabname = "stxhelpd"
    let tab[15].col_start = 79
    let tab[15].col_end = 83
    let tab[15].idx_start = 12
    let tab[15].idx_end = 12
    let tab[15].serial_start = 1000
    for n = 79 to 83
        case n
          when 79  let a="hlp_module"  let b=0  let c=8
          when 80  let a="hlp_program"  let b=0  let c=8
          when 81  let a="hlp_number"  let b=1  let c=2
          when 82  let a="line_no"  let b=1  let c=2
          when 83  let a="hlp_text"  let b=0  let c=60
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxaddlr
    let tab[16].tabname = "stxaddlr"
    let tab[16].col_start = 84
    let tab[16].col_end = 86
    let tab[16].idx_start = 13
    let tab[16].idx_end = 13
    let tab[16].serial_start = 1000
    for n = 84 to 86
        case n
          when 84  let a="filename"  let b=256  let c=18
          when 85  let a="line_no"  let b=1  let c=2
          when 86  let a="field_label"  let b=0  let c=20
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxaddld
    let tab[17].tabname = "stxaddld"
    let tab[17].col_start = 87
    let tab[17].col_end = 90
    let tab[17].idx_start = 14
    let tab[17].idx_end = 14
    let tab[17].serial_start = 1000
    for n = 87 to 90
        case n
          when 87  let a="filename"  let b=256  let c=18
          when 88  let a="record_key"  let b=0  let c=20
          when 89  let a="line_no"  let b=1  let c=2
          when 90  let a="data"  let b=0  let c=30
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxuniqc
    let tab[18].tabname = "stxuniqc"
    let tab[18].col_start = 91
    let tab[18].col_end = 91
    let tab[18].serial_start = 1000
    for n = 91 to 91
        case n
          when 91  let a="uniq"  let b=262  let c=4
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxckrgr
    let tab[19].tabname = "stxckrgr"
    let tab[19].col_start = 92
    let tab[19].col_end = 93
    let tab[19].serial_start = 1000
    for n = 92 to 93
        case n
          when 92  let a="acct_no"  let b=2  let c=4
          when 93  let a="department"  let b=0  let c=3
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxckrgd
    let tab[20].tabname = "stxckrgd"
    let tab[20].col_start = 94
    let tab[20].col_end = 101
    let tab[20].idx_start = 15
    let tab[20].idx_end = 15
    let tab[20].serial_start = 1000
    for n = 94 to 101
        case n
          when 94  let a="orig_journal"  let b=256  let c=2
          when 95  let a="doc_no"  let b=258  let c=4
          when 96  let a="acct_no"  let b=2  let c=4
          when 97  let a="department"  let b=0  let c=3
          when 98  let a="inv_chk_no"  let b=0  let c=10
          when 99  let a="amount"  let b=5  let c=3327
          when 100  let a="debit_credit"  let b=0  let c=1
          when 101  let a="reconciled"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgtranr
    let tab[21].tabname = "stgtranr"
    let tab[21].col_start = 102
    let tab[21].col_end = 106
    let tab[21].idx_start = 16
    let tab[21].idx_end = 17
    let tab[21].serial_start = 1000
    for n = 102 to 106
        case n
          when 102  let a="orig_journal"  let b=256  let c=2
          when 103  let a="doc_no"  let b=258  let c=4
          when 104  let a="acct_period"  let b=0  let c=2
          when 105  let a="acct_year"  let b=0  let c=4
          when 106  let a="status"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgactvd
    let tab[22].tabname = "stgactvd"
    let tab[22].col_start = 107
    let tab[22].col_end = 112
    let tab[22].idx_start = 18
    let tab[22].idx_end = 19
    let tab[22].serial_start = 1000
    for n = 107 to 112
        case n
          when 107  let a="orig_journal"  let b=256  let c=2
          when 108  let a="doc_no"  let b=258  let c=4
          when 109  let a="acct_no"  let b=2  let c=4
          when 110  let a="department"  let b=0  let c=3
          when 111  let a="amount"  let b=5  let c=3327
          when 112  let a="debit_credit"  let b=0  let c=1
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stxfiltr
    let tab[23].tabname = "stxfiltr"
    let tab[23].col_start = 113
    let tab[23].col_end = 115
    let tab[23].serial_start = 1000
    for n = 113 to 115
        case n
          when 113  let a="unique_id"  let b=0  let c=15
          when 114  let a="seq_no"  let b=1  let c=2
          when 115  let a="sel_filter"  let b=0  let c=200
        end case
        let col[n].colname = a
        let col[n].coltype = b
        let col[n].collength = c
    end for

    # Table: stgtranv
    let tab[24].tabname = "stgtranv"
    let tab[24].viw_start = 1
    let tab[24].viw_end = 8

    # Table: stgactvv
    let tab[25].tabname = "stgactvv"
    let tab[25].viw_start = 9
    let tab[25].viw_end = 20

    # Indexes:
    for n = 1 to 19
        case n
          when 1
            let a="i1dtablr"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 2
            let a="i1xprogr"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 3
            let a="i1xchrtr"  let d="Y"  let e="N"
            let f=1  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 4
            let a="i1xchrtd"  let d="Y"  let e="N"
            let f=1  let g=2  let h=4  let i=3
            let j=0  let k=0  let l=0  let m=0
          when 5
            let a="i1xtranr"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 6
            let a="i2xtranr"  let d="N"  let e="N"
            let f=6  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 7
            let a="i1xinfor"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 8
            let a="i1xactgd"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 9
            let a="i1xerorh"  let d="Y"  let e="N"
            let f=1  let g=2  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 10
            let a="i1xerord"  let d="N"  let e="N"
            let f=1  let g=2  let h=3  let i=4
            let j=5  let k=0  let l=0  let m=0
          when 11
            let a="i1xhelph"  let d="Y"  let e="N"
            let f=1  let g=2  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 12
            let a="i1xhelpd"  let d="N"  let e="N"
            let f=1  let g=2  let h=3  let i=4
            let j=0  let k=0  let l=0  let m=0
          when 13
            let a="i1xaddlr"  let d="N"  let e="N"
            let f=1  let g=0  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 14
            let a="i1xaddld"  let d="Y"  let e="N"
            let f=1  let g=2  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 15
            let a="i1xckrgd"  let d="N"  let e="N"
            let f=3  let g=4  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 16
            let a="i1gtranr"  let d="Y"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 17
            let a="i2gtranr"  let d="N"  let e="N"
            let f=5  let g=4  let h=3  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 18
            let a="i1gactvd"  let d="N"  let e="N"
            let f=1  let g=2  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
          when 19
            let a="i2gactvd"  let d="N"  let e="N"
            let f=3  let g=4  let h=0  let i=0
            let j=0  let k=0  let l=0  let m=0
        end case
        let idx[n].idxname = a
        let idx[n].unique_idx = d
        let idx[n].clustered = e
        let idx[n].part[1] = f
        let idx[n].part[2] = g
        let idx[n].part[3] = h
        let idx[n].part[4] = i
        let idx[n].part[5] = j
        let idx[n].part[6] = k
        let idx[n].part[7] = l
        let idx[n].part[8] = m
    end for

    # Views:
    for n = 1 to 20
        case n
          when 1 let t="create view stgtranv as  select  stxtranr.ori"
          when 2 let t="g_journal, stxtranr.doc_no,  stxtranr.post_no"
          when 3 let t=",  stxtranr.post_date, stxtranr.doc_date,  st"
          when 4 let t="xtranr.ref_code,  stxtranr.doc_desc,  stgtran"
          when 5 let t="r.acct_period,  stgtranr.acct_year,  stgtranr"
          when 6 let t=".status  from  stgtranr, stxtranr  where  stg"
          when 7 let t="tranr.orig_journal = stxtranr.orig_journal an"
          when 8 let t="d  stgtranr.doc_no=stxtranr.doc_no  ;"
          when 9 let t="create view stgactvv as  select  stxtranr.ori"
          when 10 let t="g_journal, stxtranr.doc_no,  stxtranr.post_no"
          when 11 let t=",  stxtranr.post_date, stxtranr.doc_date,  st"
          when 12 let t="xtranr.ref_code,  stxtranr.doc_desc,  stgtran"
          when 13 let t="r.acct_period,  stgtranr.acct_year,  stgtranr"
          when 14 let t=".status,  stgactvd.acct_no,  stgactvd.departm"
          when 15 let t="ent,  stgactvd.amount,  stgactvd.debit_credit"
          when 16 let t="  from  stgtranr, stxtranr, stgactvd  where"
          when 17 let t=" stgtranr.doc_no = stxtranr.doc_no and  stgtr"
          when 18 let t="anr.doc_no = stgactvd.doc_no and  stgtranr.or"
          when 19 let t="ig_journal = stxtranr.orig_journal and  stgtr"
          when 20 let t="anr.orig_journal = stgactvd.orig_journal ;"
        end case
        let viw[n].v_text = t
    end for

end function
# define_data()

