########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/minisql.4gs/main.4gl  1.7  Delta: 9/20/90
########################################################################

globals "globals.4gl"

########################################################################
main
########################################################################
#
    let quote = "\""
    let bkslsh = "\\"
    call getargs()
    call logo()
    call get_sqlfile()
    if is_just_file
    then
        call minisql()
    end if
    if is_load
    then
        call load_tables()
    end if
    if is_unload
    then
        call unload_tables()
    end if
    if is_restore
    then
        call erase_data()
        call load_tables()
    end if
    exit program (0)
end main

########################################################################
function getargs()
########################################################################
#
    define
        n       smallint    # working number

    # set some defaults
    let is_just_file = true
    let is_load = false
    let is_unload = false
    let is_restore = false
    let is_loud = true
    let db_name = "standard"

    # show usage statement
    if num_args() < 1
    then
        display
        "Usage: minisql -[d|D] database [-q] [-l|u|r dir] filename.sql"
        display ""
        display "  -d database specifies the database to use"
        display
        "  -D same as -d except minisql creates the database first"
        display "  -q run quietly (no copyright or sql strings)"
        display ""
        display
        "  -l dir:  loads data from dir/[tables].unl into tables"
        display
        "  -u dir:  unloads data to dir/[tables].unl from tables"
        display "           (requires informix-sql runtime)"
        display
        "  -r dir:  restores data from dir/[tables].unl into tables"
        display
        "           (same as -l only deletes current data first)"
        display ""
        display "  filename.sql is the name of a file that contains"
        display
        "  sql database manipulation commands (separated by semicolons)"
        exit program (1)
    end if

    # parse away...
    for n = 1 to num_args() - 1
        if arg_val(n) = "-d"
        then
            let db_name = arg_val(n+1)
        end if
        if arg_val(n) = "-D"
        then
            let db_name = arg_val(n+1)
            let sql_str = "create database ",db_name clipped
            call sql_exec()
            let sql_str = "grant dba to public"
            call sql_exec()
        end if
        if arg_val(n) = "-l"
        then
            let is_just_file = false
            let is_load = true
            let data_dir = arg_val(n+1)
        end if
        if arg_val(n) = "-u"
        then
            let is_just_file = false
            let is_unload = true
            let data_dir = arg_val(n+1)
        end if
        if arg_val(n) = "-r"
        then
            let is_just_file = false
            let is_restore = true
            let data_dir = arg_val(n+1)
        end if
        if arg_val(n) = "-q"
        then
            let is_loud = false
        end if
    end for

    let sql_str = "database ",db_name clipped
    call sql_exec()

    # set the sql filename
    let sql_file = arg_val(num_args())

end function
# getargs()

########################################################################
function logo()
########################################################################
#
    if is_loud
    then
        display "minisql"
        display "Copyright (c) 1988,1989 FourGen Software Technologies, Inc."
        display "Author:  Loren West"
        display ""
    end if
end function
# logo()

########################################################################
function sql_exec()
########################################################################
#
    define
        x smallint,              # temp. variable
        tmp_sqlstr char(50)      # temp. sql string

    # show it off...
    if is_loud
    then
        display sql_str clipped
        display ""
    end if

    # if it's a select string, then it's a different animal altogether
    if   sql_str[1,7] = "select "
    then
        call sql_select()
        let sql_str = ""
        return
    end if

    # make sure what is created isn't around already...
    if   sql_str[1,7] = "create "
     and sql_str[1,15] != "create database"
    then
        let x = 7
        while sql_str[x,x] = " "
            let x = x + 1
        end while
        while sql_str[x,x] != " "
            let x = x + 1
        end while
        while sql_str[x,x] = " "
            let x = x + 1
        end while
        while sql_str[x,x] != " "
            let x = x + 1
        end while
        let tmp_sqlstr = "drop",sql_str[7,x]
        # don't bomb if not there already...
        whenever error continue
        prepare tmp_stmt from tmp_sqlstr
        execute tmp_stmt
        whenever error stop
    end if
    
    # prepare and execute the sql_str
    whenever error continue
    prepare exec_stmt from sql_str
    if sqlca.sqlcode = 0 then execute exec_stmt end if
    if sqlca.sqlcode != 0
    then
        display sqlca.sqlcode using "SQL error number: -<<<<<<<",
                " occurred on the previous command."
        display ""
        exit program (1)
    end if

    # clear it out (we're done)
    let sql_str = ""

end function
# sql_exec()
