##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../data/minisql.4gs/unload.4gl  1.1  Last Delta: 10/25/88
##############################################################################

globals "globals.4gl"

###########################################################################
function unload_tables()
###########################################################################
#  The purpose of this function is to erase the data defined in the
#  sql script.
#
    define
        scratch char(255),    # scratch string storage
        execflag smallint,    # execute this time ?
        x smallint,           # working number
        n smallint            # working number


    let scratch = "mkdir ",data_dir clipped, " 2>/dev/null"
    run scratch

    start report oneline to "unload.sql"

    declare unload_curs cursor for
        select data from tmp_table

    # make sure we have a clean sql_str to start with
    let sql_str = ""

    foreach unload_curs into scratch
        let n = length(scratch)
        let x = 1
        while scratch[x,x] = " "
            let x = x + 1
        end while
        if scratch[n,n] = ";"
        then
            let n = n - 1
            let execflag = true
        else
            let execflag = false
        end if

        if sql_str is null
        then
            let sql_str = scratch[x,n]
        else
            let sql_str = sql_str clipped, " ", scratch[x,n]
        end if

        if execflag
        then
            call unl_exec()
        end if
    end foreach

    if sql_str is not null
    then
        call unl_exec()
    end if

    finish report oneline

    # unload data from database...

    let sql_str = "isql -s ",db_name clipped, " -qcr unload"
    run sql_str
    let sql_str = "rm -f unload.sql"
    run sql_str

    return
end function
# unload_tables()

###########################################################################
function unl_exec()
###########################################################################
#  This function determines if there is anything to delete
#  sql script.
#
    define
        scratch char(255),    # scratch string storage
        x smallint,           # working number
        n smallint,           # working number
        m smallint            # working number

    if sql_str[1,12] = "create table"
    then
        let x = 14
        while sql_str[x,x] = " "
            let x = x + 1
        end while
        let n = x
        while sql_str[n,n] != " "
            let n = n + 1
        end while
        let n = n - 1
        let scratch = sql_str[x,n]

        display "Writing SQL script for ",scratch clipped

        let sql_str = "unload to ",quote,data_dir clipped, "/",
            scratch clipped, ".unl", quote, " select * from ",
            scratch clipped, " order by 1,2;"
        output to report oneline(sql_str)
    end if
    if sql_str[1,14] = "define data in"
    then
        let x = 16
        while sql_str[x,x] = " "
            let x = x + 1
        end while
        let n = x
        while sql_str[n,n] != " "
            let n = n + 1
        end while
        let n = n - 1
        let scratch = sql_str[x,n]
        display "Writing SQL script for ",scratch clipped
        let m = length(sql_str)
        let scratch = sql_str[x,m]

        let sql_str = "unload to ",quote,data_dir clipped, "/",
            scratch[1,n-x+1] , ".unl", quote, " select * from ",
            scratch clipped, " order by 1,2;"
        output to report oneline(sql_str)
    end if
    let sql_str = ""
end function
# unl_exec()
