:
########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../install/all/acct_ins.sh  1.4  Delta: 9/10/90
########################################################################

dn=/dev/null
DBDATE=mdy2/                 ; export DBDATE
SHELL=/bin/sh                ; export SHELL

# set some defaults (if not already set)
if test ${INFORMIXDIR:=empty} = empty
then
    test -d /usr/informix && INFORMIXDIR=/usr/informix
    test -d /usr2/informix && INFORMIXDIR=/usr2/informix
    if test $INFORMIXDIR = empty
    then
        echo "The \$INFORMIXDIR system variable needs to be set."
        echo "The \$INFORMIXDIR system variable needs to be set." 1>&2
        exit 1
    else
        export INFORMIXDIR
    fi
fi

: ${fd:=$fg}; export fd
PATH=$INFORMIXDIR/bin:$fd/bin:$PATH; export PATH

# set the module-specific variables
if test $# -lt 2
then
    echo "Syntax: $0 module \"module name\""
    echo "Syntax: $0 module \"module name\"" 1>&2
    exit 1
fi
module=$1
mod_name=$2
if test $module = all
then
    logo=$fg/accounting/lib.4gm/all.4gs/logo.4gl
else
    logo=$fg/accounting/lib.4gm/$module.4gs/${module}_logo.4gl
fi

# get rid of duplicates in DBPATH; make sure fourgen's is first, but
# after that, preserve the original order.
DBPATH=$fg/accounting/data:$DBPATH
db_dirs=`echo $DBPATH | sed 's/:/ /g'`
dup_dir_chk=" :"
DBPATH=`for db_dir in $db_dirs
        do
            if expr "$dup_dir_chk" : ".*:$db_dir:" > /dev/null
            then :
            else
                echo $db_dir
                dup_dir_chk=$dup_dir_chk$db_dir:
            fi
        done`
DBPATH=`echo $DBPATH | sed 's/ /:/g'`; export DBPATH

MAKE=make; export MAKE
DBMERGE=$module/dbmerge.4ge
if test -x $INFORMIXDIR/bin/fglpc
then
    MAKE=make.rds; export MAKE
    DBMERGE="fglgo $module/dbmerge.4gi"
fi

# if logo.4gl isn't in the library, then we're not a source code product
if test -f $logo
  then source=yes
  else source=no
fi

if test $source = no
then
    MAKE=/bin/true; export MAKE
    DBMERGE="fglgo $module/dbmerge.4gi"
fi

# if we are a source product, then we want to change the release number
# in the logo and def files.
if test $source = yes
then
    sed -e '/^version/s/1\([0-9]\)"/0\1"/' \
           $fg/accounting/install/$module/def > /tmp/def$$ &&
           mv /tmp/def$$ $fg/accounting/install/$module/def
    sed -e '/MODIFIABLE ACCOUNTING/s/1\([0-9]\)"/0\1"/' \
           $logo > /tmp/logo$$ &&
           mv /tmp/logo$$ $logo
fi

# in altos unix, some installations use xar as their archiver.  if
# installing basefiles and this is the case, change our archiver to
# match.
if test $module = all
then
    if test -x /bin/xar -a $source = yes
    then
        libfile=`ls $INFORMIXDIR/lib/*.a | sed -n 1p`
        if /bin/xar t $libfile >$dn
        then
            sed "s/ARCMD=ar/ARCMD=xar/" < $fg/Make/library \
                > /tmp/make$$ &&
                mv /tmp/make$$ $fg/Make/library
        fi
        if sed "s/ar /xar /" < $fg/bin/lib_check > /tmp/make$$ 2>$dn
        then
            mv /tmp/make$$ $fg/bin/lib_check
            chmod 555 $fg/bin/lib_check
        fi
    fi
fi

# make dbmerge
cd $fg/accounting/data/$module
$MAKE || exit 1
cd $fg/accounting/data

# if installing basefiles, make minisql
if test $module = all
then
    rm -f minisql.4gs/minisql.4ge
    $MAKE || exit 1
fi

# create the logfile
if test ! -f $fg/accounting/data/logfile
then
    > $fg/accounting/data/logfile
    chmod 666 $fg/accounting/data/logfile
    chgrp informix $fg/accounting/data/logfile
    chown informix $fg/accounting/data/logfile
fi

# install the databases & data

# merge the new schemas into other existing databases
$fg/accounting/bin/merge_db $module

echo "Creating $mod_name tables for the standard database..."
$DBMERGE -d standard -l $module/data.standard || exit 1
chown informix standard.dbs >$dn 2>&1
chgrp informix standard.dbs >$dn 2>&1
# check the indexes
$DBMERGE -d standard -i || exit 1

echo "Creating $mod_name tables for the sample database..."
$DBMERGE -d sample -l $module/data.sample || exit 1
chown informix sample.dbs >$dn 2>&1
chgrp informix sample.dbs >$dn 2>&1
# check the indexes
$DBMERGE -d sample -i || exit 1

# Compile the source code
if test $source = yes
then
    # compile the user interface libraries
    if test $module = all
    then
        echo "Compiling the user interface libraries..."
        cd $fg/lib/screen.4gs
        $MAKE || exit 1
        cd $fg/lib/report.4gs
        $MAKE || exit 1
        cd $fg/lib/standard.4gs
        $MAKE || exit 1
    fi

    # make the accounting libraries
    echo "Compiling the $mod_name libraries..."
    cd $fg/accounting/lib.4gm/$module.4gs
    $MAKE || exit 1

    # if installing base files or g/l, make the g/l detail & summary
    # reports know if g/l is installed.  compile them if this is g/l.
    # if base files, they'll be compiled anyway later.
    if test $module = all -o $module = gl
    then
        cd $fg/accounting/all.4gm/o_gldetl.4gs
        ./make_gl.sh || exit 1
        if test $module = gl
        then
            $MAKE || exit 1
        fi
        cd $fg/accounting/all.4gm/o_glsmry.4gs
        ./make_gl.sh || exit 1
        if test $module = gl
        then
            $MAKE || exit 1
        fi
    fi

    # make the accounting programs
    cd $fg/accounting/$module.4gm
    echo "Compiling the accounting $mod_name programs..."
    touch */globals.4gl
    $MAKE || exit 1
fi

# Install the main accounting menu
if test -f $fg/accounting/bin/makemenu
then
    $fg/accounting/bin/makemenu > $fg/accounting/menu/mainmenu/main/menu
fi
